{{ ucfunc("put_docready_start") }}

    //ids
    var widgetId = "{{uc_id}}";

    //classes
    var contentSwitcherBodyClass = "uc_tab-slider--body";
    var ueElementClass = "ue-element";
    var tabTriggerClass = "uc_tab-slider--trigger";
    var bodyContainerClass = "uc_tab-slider--container";
    var navLinkClass = "uc-tab-slider__link";
    var tabsContainerClass = "uc_tab-slider--tabs";
    var magicLineClass = "uc_flex-tab";
    var activeClass = "active";
    var ucActiveClass = "uc_active";  

    //selectors
    var widgetSelector = "#"+widgetId;
    var contentSwitcherBodySelector = "."+contentSwitcherBodyClass;
    var ueElementSelector = "."+ueElementClass;
    var tabTriggerSelector = "."+tabTriggerClass;
    var bodyContainerSelector = "."+bodyContainerClass;
    var navLinkSelector = "."+navLinkClass;
    var tabsContainerSelector = "."+tabsContainerClass;
    var magicLineSelector = "."+magicLineClass;

    //objects
    var objTabsWrapper = jQuery(widgetSelector);
    var objContentSwitcherBodies = objTabsWrapper.find(contentSwitcherBodySelector);
    var objUeElements = objTabsWrapper.find(ueElementSelector);
    var objTabTriggers = objTabsWrapper.find(tabTriggerSelector);
    var objBodyContainer = objTabsWrapper.find(bodyContainerSelector);
    var objNavLinks = objTabsWrapper.find(navLinkSelector);
    var objTabsContainer = objTabsWrapper.find(tabsContainerSelector);
    var objMagicLine;

    //attr
    var dataDebug = objBodyContainer.data("debug");
    var dataEditor = objBodyContainer.data("editor");
    var dataCookie = objBodyContainer.data("cookie");
    var dataCookieName = widgetId+"_"+objBodyContainer.data("cookie-name");  

    //helpers
    var elementParentIndex;
    var elementParentIndexArray = [];
    var elementsId;
    var leftPos;
    var newWidth;
    var currentTabIndex = 0;
    var customCookieName = "ue_content_switcher_" + dataCookieName;

    /**
    * enables elementor swiper widget`s proper work inside content switcher widget
    */
    function initSwiperWidgetProtection(){    
      var objSwippers = objTabsWrapper.find(".swiper");

      if(!objSwippers)
      return(false);    

      objSwippers.each(function(){    
        var objSwiper = jQuery(this);
        var objParentTabContainer = objSwiper.parents(contentSwitcherBodySelector);
        var isVisible = objParentTabContainer.css("display") != "none";

        if(isVisible == true)
        return(true);

        var objSliders = objSwiper.find(".swiper-slide");

        if(!objSliders)
        return(true);

        objSliders.each(function(){        
          var objSlide = jQuery(this);

          if(objSlide.attr('inert') !== undefined)
          objSlide.removeAttr('inert');   
        });     
      });        
    }

    /*
    * hide container when tab with elements to show is clicked        
    */ 
    function hideBodyContainers(){

      objUeElements.each(function(){
        var objElement = jQuery(this);
        var objParentElement = objElement.parents(contentSwitcherBodySelector);

        objParentElement.hide();
      });        
    }

    /*
    * hide all elements
    */     
    function hideElements(){

      objUeElements.each(function(){            
        elementsId = jQuery(this).data('id');

        var elementsIdArray = elementsId.split(',');

        elementsIdArray.forEach(function(value){                
          var objElement = jQuery("#"+value);

          objElement.hide();

          objElement.removeClass(activeClass);

          // show elements if in editor and debug mode is true   
          if(dataDebug == true && dataEditor == 'yes'){
            objElement.fadeIn();
            objElement.css({'border': '3px solid red'});

          }else{
            objElement.css({'border': 'unset'});

          }
        });
      });
    }

    /**
    * get current index
    */
    function getCurrentTabIndex(){

      currentTabIndex = objTabsWrapper.find(tabTriggerSelector+'.'+ucActiveClass).index(); 

      return(currentTabIndex);

    }

    /*
    * find active elements
    */
    function showActive(){

      objContentSwitcherBodies.find(ueElementSelector).removeClass(activeClass);
      objContentSwitcherBodies.eq(currentTabIndex).find(ueElementSelector).addClass(activeClass);

      var objActiveElements = objTabsWrapper.find(ueElementSelector+'.'+activeClass);

      //each child element with source: element id
      objActiveElements.each(function(){
        //array of ids
        elementsId = jQuery(this).data('id');

        var elementsIdArray = elementsId.split(',');

        //each id in array
        elementsIdArray.forEach(function(value){

          var element = jQuery("#" + value);

          //each element by id
          elementParentIndexArray.forEach(function(index, value){

            //show current and hide others
            if(currentTabIndex == index){
              element.show();
              element.addClass(activeClass);

              hideBodyContainers();

            }//end if  

          });//end each element by id                
        });//end each id in array
      });//end each child element with source: element id
    } 

    /**
    * set magic line size and position
    */
    function setMagicLine(objLink){

      if(!objLink)
      objLink = objTabsWrapper.find("."+ucActiveClass+" "+navLinkSelector);

      var objParentTab = objLink.parents(tabTriggerSelector);
      var magicLineWidth = objParentTab.width();
      var magicLineLeftPos = objLink.position().left;

      objMagicLine.width(magicLineWidth);	    
      objMagicLine.height(objTabsContainer.height())
      objMagicLine.css("left", magicLineLeftPos);  
    }

    /**
    * init magic line
    */
    function initMagicLine(){
      objTabsContainer.append("<li class='"+magicLineClass+"'></li>");

      objMagicLine = objTabsWrapper.find(magicLineSelector);

      //set position and size
      setMagicLine();

    }

    /**
    * update magic line position after nav link click
    */
    function updateMagicLinePosition(objLink){
      var objActiveParent = objLink.parent(tabTriggerSelector);

      //don't do anything if clicked link is active already
      if(objActiveParent.hasClass(ucActiveClass))
      return(true);

      //remove active class from all parent containers
      objTabTriggers.removeClass(ucActiveClass);

      //assign active class to the clicked container
      objActiveParent.addClass(ucActiveClass);

      leftPos = objLink.position().left;
      newWidth = objLink.parent().width();

      objMagicLine.stop().animate({
        left: leftPos,
        width: newWidth
      });

      //update current index
      currentTabIndex = getCurrentTabIndex();

    }  

    /**
    * set cookie name
    */
    function setCookie(value){    

      if(dataCookie == false)
      return(false);

      //get data time values in miliseconds
      var dataCookieDays = objBodyContainer.data("cookie-days") * 24 * 60 * 60 * 1000;
      var dataCookieHours = objBodyContainer.data("cookie-hours") * 60 * 60 * 1000;
      var dataCookieMinutes = objBodyContainer.data("cookie-min") * 60 * 1000;
      var dataCookieSeconds = objBodyContainer.data("cookie-sec") * 1000;

      var ue_expires = new Date();    

      ue_expires.setTime(ue_expires.getTime() + dataCookieDays + dataCookieHours + dataCookieMinutes + dataCookieSeconds);

      document.cookie = customCookieName + "=" + value + "; expires=" + ue_expires.toUTCString() + ";";

    }

    /*
    * check cookie and open tab from it
    */  
    function checkCookieAndOpenLastTab(){

      if(dataCookie == false)
      return(false);

      var lastTab = Cookies.get(customCookieName);

      if(!lastTab)
      return(false);

      var objLastTabLink = objTabsWrapper.find('[data-id="'+ lastTab +'"]');

      objLastTabLink.trigger("click");      
    }

    /**
    * click on nav link
    */
    function onNavLinkClick(objLink){

      //init swiper protection 
      initSwiperWidgetProtection(objLink);

      //some unknown protection
      if(objLink.hasClass(navLinkClass) == false)
      return(true);    

      //update magic line position and size
      updateMagicLinePosition(objLink);

      //hide all connected elements
      hideElements();

      //show active elements
      showActive(currentTabIndex);

      //hide all content bodies
      objContentSwitcherBodies.hide();

      var activeTabId = objLink.attr("data-id");

      //shows active body content element
      jQuery("#"+activeTabId).fadeIn();

      //set cookie
      setCookie(activeTabId)

    }

    /**
    * init content switcher
    */
    function startToggle(){	  

      //hide all content bodies
      objContentSwitcherBodies.hide();

      //show first content body
      var objFirstContentBody = objContentSwitcherBodies.eq(0);
      var objFirstContentBodyChild = objFirstContentBody.find("> div");

      //show first content body only if it's not an Element source (with source type elements will be shown later)
      if(objFirstContentBodyChild.hasClass(ueElementClass) == false)
      objFirstContentBody.show();   

      var objFirstNavItem = objTabTriggers.eq(0);

      //activate firs nav item
      objFirstNavItem.addClass(ucActiveClass);

      //code for content type set to 'element id'        
      var objElementParentBodies = objUeElements.parents(contentSwitcherBodySelector);

      //detect which container bodies have element as source
      objElementParentBodies.each(function(){        
        elementParentIndex = jQuery(this).index();
        elementParentIndexArray.push(elementParentIndex);

      });

      //init swiper protection    
      initSwiperWidgetProtection();      

      //hide connected elements
      hideElements();

      //show active elements
      showActive();      

      //init magic line
      initMagicLine();
      
      //check cookie
      setTimeout(checkCookieAndOpenLastTab, 1100);      
    }

    //init content switcher
    startToggle();

    //init events
    objNavLinks.on('click', function(){
      var objLink = jQuery(this);
    	onNavLinkClick(objLink);
      
    });

    objTabsWrapper.on("uc_ajax_refreshed",function(){

      var objChildFilter = objTabsWrapper.find(".uc-grid-filter");

      //protection that allows using filters inside content switcher items
      if(!objChildFilter || objChildFilter.length == 0)
      startToggle();

    });

    var objRemoteOptions = {
      class_items:"uc_tab-slider--trigger",
      class_active:"uc_active",
      selector_item_trigger:"a"
    };  

    {{ucfunc("put_remote_parent_js","objTabsWrapper","objRemoteOptions")}}  

{{ ucfunc("put_docready_end") }}